unit UFrmGestion;

// |===========================================================================|
// | UNITE UFrmGestion                                                         |
// | dvelopp par F.BASSO 2006                                                |
// | Unit permetant la gestion de la liste des logiciels                      |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |   1.0.0.0 cration unit                                                  |
// |===========================================================================|

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,uxml;

type
  TfrmGestion = class(TForm)
    lstProgramme: TListBox;
    Label1: TLabel;
    strNomProgramme: TEdit;
    strCible: TEdit;
    strCommande: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    cmdNouveau: TBitBtn;
    cmdSupprimer: TBitBtn;
    cmdOk: TBitBtn;
    cmdAnnuler: TBitBtn;
    cmdFermer: TBitBtn;
    booEditable: TCheckBox;
    booNouveau: TCheckBox;
    booModifie: TCheckBox;
    cmdNaviguer: TButton;
    cmdNavigue2: TButton;
    OpenDialog1: TOpenDialog;
    procedure cmdNavigue2Click(Sender: TObject);
    procedure cmdNaviguerClick(Sender: TObject);
    procedure cmdOkClick(Sender: TObject);
    procedure cmdSupprimerClick(Sender: TObject);
    procedure booModifieClick(Sender: TObject);
    procedure strNomProgrammeChange(Sender: TObject);
    procedure booNouveauClick(Sender: TObject);
    procedure cmdNouveauClick(Sender: TObject);
    procedure cmdAnnulerClick(Sender: TObject);
    procedure booEditableClick(Sender: TObject);
    procedure lstProgrammeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cmdFermerClick(Sender: TObject);
  private
// ****************************************************************************
// * Dclarations prives                                                     *
// ****************************************************************************
    tabfichier   : ttabfichier ;
    intnbfichier : integer;
  public
// ****************************************************************************
// * Dclarations publiques                                                   *
// ****************************************************************************
  end;

var
  frmGestion: TfrmGestion;

implementation

{$R *.dfm}

uses ufrmmaitre;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Partie vnementiel                                                       #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

procedure TfrmGestion.cmdFermerClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdFermerClick                                       |
// | _________________________________________________________________________ |
// || Permet de fermer la fentre                                             ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  modalresult := mrok;
end;

procedure TfrmGestion.FormShow(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.FormShow                                             |
// | _________________________________________________________________________ |
// || Permet de charger la liste des programme                                ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var i : integer;
begin
  lstProgramme.Items.Clear ;
  intnbfichier := frmMaitre.mdlXml.ChargerFichier(tabfichier);
  frmMaitre.TrieTableau(tabFichier) ;
  for i :=0 to intnbFichier -1 do
    lstprogramme.Items.Add(tabfichier[i].nom);
  booEditable.Checked := false;
  booEditableClick(self);
  booNouveau.Checked := false;
  strNomProgramme.text := '';
  strCible.text        := '';
  strCommande.text     := '';
  strNomProgrammeChange(self);
  booModifieClick(self);
end;

procedure TfrmGestion.lstProgrammeClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.lstProgrammeClick                                    |
// | _________________________________________________________________________ |
// || Permet d'afficher le dtail du programme                                ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if lstProgramme.ItemIndex <> - 1 then
  begin
    booEditable.Checked  := true;
    strNomProgramme.text := tabfichier[lstprogramme.ItemIndex].nom;
    strCible.text        := tabfichier[lstprogramme.ItemIndex].exe;
    strCommande.text     := tabfichier[lstprogramme.ItemIndex].com;
  end else
    booEditable.Checked  := false;

end;

procedure TfrmGestion.booEditableClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.booEditableClick                                     |
// | _________________________________________________________________________ |
// || Permet d'autoriser les modifs ou non                                    ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  strNomProgramme.Enabled := booEditable.Checked;
  strCible.Enabled        := booEditable.Checked;
  strCommande.Enabled     := booEditable.Checked;
  cmdSupprimer.Enabled    := booEditable.Checked and (lstProgramme.ItemIndex <>-1);
end;

procedure TfrmGestion.cmdAnnulerClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdAnnulerClick                                      |
// | _________________________________________________________________________ |
// || Permet d'annuler les modifications en cours                             ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  booNouveau.Checked := false;
  lstProgrammeClick(self);
end;

procedure TfrmGestion.cmdNouveauClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdNouveauClick                                      |
// | _________________________________________________________________________ |
// || Permet d'ajouter un nouveau programme                                   ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  booNouveau.Checked   := true;
  booEditable.Checked  := true;
  strNomProgramme.text := '';
  strCible.text        := '';
  strCommande.text     := '';
end;

procedure TfrmGestion.booNouveauClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.booNouveauClick                                      |
// | _________________________________________________________________________ |
// || Permet de pointer l'ajout d'un nouveau programme                        ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  lstProgramme.Enabled := not booNouveau.Checked ;
  cmdNouveau.Enabled   := not booNouveau.Checked ;
  cmdSupprimer.Enabled := not booNouveau.Checked ;
  cmdAnnuler.Enabled   := true;
end;

procedure TfrmGestion.strNomProgrammeChange(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.strNomProgrammeChange                                |
// | _________________________________________________________________________ |
// || Permet de savoir s'il y a modification                                  ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if not booNouveau.Checked and (lstprogramme.ItemIndex<>-1)then
    booModifie.Checked := (strNomProgramme.text <> tabfichier[lstprogramme.ItemIndex].nom) or
                     (strCible.text <> tabfichier[lstprogramme.ItemIndex].exe) or
                     (strCommande.text <> tabfichier[lstprogramme.ItemIndex].com)
  else
    booModifie.Checked := (strNomProgramme.text <>'') and ( strCible.text <>'');
end;

procedure TfrmGestion.booModifieClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.booModifieClick                                      |
// | _________________________________________________________________________ |
// || Permet pointer la modification                                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  cmdok.Enabled      := booModifie.Checked ;
  cmdAnnuler.Enabled := booModifie.Checked or booNouveau.Checked  ;
end;

procedure TfrmGestion.cmdSupprimerClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdSupprimerClick                                    |
// | _________________________________________________________________________ |
// || Permet de supprimer un programme                                        ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  i , j :integer;
begin
  if MessageDlg('Voulez vous vraiment supprimer ' + strNomProgramme.Text + ' ?',mtConfirmation ,[mbYes ,mbNo ],0)= mryes then
  begin
    j := lstProgramme.ItemIndex ;
    for i := j to intnbfichier -2 do
      tabfichier[i] := tabfichier[i+1];
    SetLength(tabfichier, intnbfichier -1);
    frmMaitre.mdlXml.SauverFichier(tabfichier);
    FormShow(self);
  end;
end;

procedure TfrmGestion.cmdOkClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdOkClick                                           |
// | _________________________________________________________________________ |
// || Permet de valider un ajout ou une modification                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin

// ****************************************************************************
// * Ajout d'un nouveau programme                                             *
// ****************************************************************************

  if booNouveau.Checked then
  begin
    if intnbfichier =-1 then intnbfichier :=0;
    setlength(tabfichier,intnbfichier+1);
    tabfichier[intnbfichier ].nom := strNomProgramme.text;
    tabfichier[intnbfichier ].exe := strCible.Text ;
    tabfichier[intnbfichier ].com := strCommande.Text ;
    frmMaitre.mdlXml.SauverFichier(tabfichier);
    FormShow(self);
  end else

// ****************************************************************************
// * Modification d'un programme                                              *
// ****************************************************************************

  if booModifie.Checked then
  begin
    tabfichier[lstProgramme.ItemIndex ].nom := strNomProgramme.text;
    tabfichier[lstProgramme.ItemIndex ].exe := strCible.Text ;
    tabfichier[lstProgramme.ItemIndex ].com := strCommande.Text ;
    frmMaitre.mdlXml.SauverFichier(tabfichier);
    FormShow(self);
  end;
end;

procedure TfrmGestion.cmdNaviguerClick(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdNaviguerClick                                     |
// | _________________________________________________________________________ |
// || Permet d'ouvrir la boite de dialogue d'ouverture de fichier pour le     ||
// || champ cible                                                             ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if OpenDialog1.Execute then
    strCible.Text := OpenDialog1.FileName ;
end;

procedure TfrmGestion.cmdNavigue2Click(Sender: TObject);

//  ___________________________________________________________________________
// | procedure TfrmMaitre.cmdNavigue2Click                                     |
// | _________________________________________________________________________ |
// || Permet d'ouvrir la boite de dialogue d'ouverture de fichier pour le     ||
// || champ commande                                                          ||
// ||_________________________________________________________________________||
// || Entres | Sender: TObject                                               ||
// ||         |   Objet metteur de l'vnement                               ||
// ||_________|_______________________________________________________________||
// || Sorties |                                                               ||
// ||         |                                                               ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

begin
  if OpenDialog1.Execute then
    strCommande.Text := OpenDialog1.FileName ;
end;

end.
